#include <iostream>
#include <cmath>
#include "Evaluator.hpp"

using namespace std;

Evaluator::Evaluator()
{
}

double Evaluator::evaluate(Individual &ind, Context &context)
{
	double dFit,dError;
	int iHits=0;
	Result* pres;
	context.setArgumentValue("x", new Result(2.5));
	pres = ind.execute(context);
	dError = fabs(42.0-(pres->toDouble()));

	if(dError < 1)
	{
		iHits++;
	}

	dFit = 1/(1+dError);
	
	delete pres;
	context.clear();

	ind.setHits(iHits);
	return dFit;
}

Evaluator::~Evaluator()
{
}
