#include <iostream>
#include "FDiv.hpp"
#include "cstdarg"

using namespace std;

FDiv::FDiv()
{
	pvpgramExpression = NULL;
	strGrammarID = "DIV";
}

Result* FDiv::execute(Context &context)
{
	Result* pres;
	Result* pres1 = vpresArguments.at(0);
	Result* pres2 = vpresArguments.at(1);

	//Like in Koza's GP no input can result in an error.  We must define
	//a safe division where would be undefined values are caught and
	//handled.
	if(pres2->toDouble() != 0)
	{
		pres = new Result((pres1->toDouble())/(pres2->toDouble()));
	}
	else
	{
		pres = new Result(1.0);
	}

	return pres;
}

Grammar* FDiv::clone()
{
	Grammar* pfaddClone = new FDiv();
	return pfaddClone;
}

FDiv::~FDiv()
{
}

