#include "FConst.hpp"
#include <iostream>
#include <sstream>
using namespace std;

FConst::FConst(double dConst)
{
	if(dConst == HUGE_VAL)
	{
		generateValue();
	}
	else
	{
		this->dConst = dConst;
	}

	stringstream ss;
	ss << this->dConst;
	strGrammarID = ss.str();
	pvpgramExpression = NULL;
}

Result* FConst::execute(Context &context)
{
	Result* res = new Result();
	res->setValue(dConst);
	return res;
}

void FConst::generateValue()
{
	dConst = double(rand())/RAND_MAX*10.0;
}

Grammar* FConst::clone()
{
	Grammar* pfcClone = new FConst(dConst);
	return pfcClone;
}

FConst::~FConst()
{
}
